<?php
extract($_GET);
extract($_POST);
###########################################################################
#  image resizer
#  (c) 2008 by Peter Garstenauer & Reynhard Boegl for kick-image.at
#  Free Download: http://www.kick-image.at > WEBTOOLS
###########################################################################

###########################################################################
#  Smtliche, zum Download zur Verfgung gestellten Dateien werden
#  von kick-image.at sorgfltig auf Viren und andere Schdlinge
#  berprft. kick-image.at bernimmt jedoch keinerlei Haftung fr
#  eventuell entstehende Schden jeglicher Art, alle Downloads sind
#  freiwillig und auf eigene Gefahr!
###########################################################################

###########################################################################
#  Einstellungen:
###########################################################################

## Pfad des Ordners der original Bilder - Inhalt bleibt beim Skalieren im Original erhalten
$images_source_path = 'picssource';

## Bilder Gross
# Pfad des Ordners der Bilder Gross (Ort der _pics.txt-Datei)
$images_big_path = 'pics';
# maximale Breite
$image_big_width = '500';
# maximale Hhe
$image_big_height = '';
# Qualitt
$quality_image_big = '85';

## Bilder Klein
# Pfad des Ordners der Bilder Klein
$thumbnails_path = 'thumbs';
# maximale Breite
$thumbnails_width = '';
# maximale Hhe
$thumbnails_height = '60';
# Qualitt
$quality_thumbnails = '85';

## Sprach-Einstellungen
$lang['title'] = 'Image Resizer';
$lang['skal_einst'] = 'Skalierungs-Einstellungen:';
$lang['orig'] = '<b>Original:</b> ';
$lang['gross'] = '<b>Gross:</b> ';
$lang['klein'] = '<b>Klein:</b> ';
$lang['pfad'] = 'Pfad: ';
$lang['max_breite'] = 'Max. Breite: ';
$lang['max_hoehe'] = 'Max. H&ouml;he: ';
$lang['qualitaet'] = 'Qualit&auml;t: ';
$lang['starten'] = 'Image Resizer starten';
$lang['erfolgreich'] = 'Folgende Bilder wurden erfolgreich skaliert:';
$lang['fusstext'] = 'Dateien im Format .gif werden in das Format .jpg umgewandelt. Die Original-Dateien bleiben im Ordner "[orig]" erhalten. Die Text-Datei <b>"_pics.txt"</b> im Ordner "[gross]" wird erstellt bzw. ge&auml;ndert, die Namen neuer Bilder werden am Ende eingef&uuml;gt.';

###########################################################################
#  Ende Einstellungen:
###########################################################################
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="de">

<head>
<title><?php echo $lang['title']; ?></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<style type="text/css">
<!--
* {padding:0; margin:0;}
body {font-family:Arial,Verdana,sans-serif; font-size:86%; padding:20px; background-color:#fff;}
h1 {font-size:1.3em; border-bottom:1px solid #ccc; margin:0 0 20px 0;}
h2 {font-size:1.2em; padding:0 0 5px 0; margin:20px 0 0 0;}
div {background-color:#efefef; padding:25px 0 25px 15px; margin:0 0 20px 0; border:1px solid #ccc;}
p {padding:0 0 0 15px;}
p#start a {display:block; font-weight:bold; font-size:1.3em; background-color:#efefef; border:1px solid #f00; padding:8px; margin:15px 0 0 -15px; text-align:center;}
p#start a:hover {text-decoration:none;} 
p.fn {padding:0; font-size:0.9em; margin:15px 0 0 0;}
p#copy {margin:45px 0 0 0; border-top:1px solid #000; padding:3px 0 0 0;}
a {color:#000;}
-->
</style>
</head>

<body>

<?php
if (is_file("gallery_framework_menue.php")) { // wird nur im Gallery Framework bentigt
	include ("gallery_framework_menue.php");
}
?>

<h1><?php echo $lang['title']; ?></h1>

<h2><?php echo $lang['skal_einst']; ?></h2>
<p>
<?php echo $lang['orig'].$lang['pfad'].$images_source_path ?>
</p>
<p>
<?php echo $lang['gross'].$lang['pfad'].$images_big_path." / ".$lang['max_breite'].$image_big_width."px / ".$lang['max_hoehe'].$image_big_height."px / ".$lang['qualitaet'].$quality_image_big ?>
</p>
<p>
<?php echo $lang['klein'].$lang['pfad'].$thumbnails_path." / ".$lang['max_breite'].$thumbnails_width."px / ".$lang['max_hoehe'].$thumbnails_height."px / ".$lang['qualitaet'].$quality_thumbnails ?>
</p>

<?php


$ersatz['[orig]'] = $images_source_path;
$ersatz['[gross]'] = $images_big_path;
$lang['fusstext'] = strtr($lang['fusstext'], $ersatz);
echo "<p class='fn'>" . $lang['fusstext'] . "</p>";
?>

<p id="start"><a href="<?php echo $_SERVER['PHP_SELF']."?start=1\">".$lang['starten']."</a>" ?></p>

<?php


// soll nur ablaufen wenn der start-link (die zeile darber) geklickt wurde...
if ($start == "1") {
	echo "<h2>" . $lang['erfolgreich'] . "</h2>";
	echo "<div>";
	$existing_pics_list = array ();
	if (is_file($images_big_path . '/_pics.txt')) {
		$existing_pics_list = file($images_big_path . '/_pics.txt');
		foreach ($existing_pics_list as $k => $v) {
			preg_match("#^([^\s]+)#", $v, $treffer);
			$existing_pics_list[$k] = $treffer[1];
		}
	}
	sort($existing_pics_list);
	$_pics_text = '';
	$dh = opendir($images_source_path);
	while (strlen($datei = readdir($dh)) > 0) {
		if (preg_match('#\.jpg$|\.png$|\.gif$#i', $datei) and is_file($images_source_path . '/' . $datei)) {
			if (!in_array(preg_replace('#\.gif$#i', '.jpg', $datei), $existing_pics_list)) {
				$pics_text .= preg_replace('#(\.gif)$#i', '.jpg', $datei) . "\r\n";
			}
			if ($thumbnails_path and is_dir($thumbnails_path)) {
				scale_image($images_source_path . '/' . $datei, $thumbnails_width, $thumbnails_height, $thumbnails_path . '/' . $datei, $quality_thumbnails);
			}
			scale_image($images_source_path . '/' . $datei, $image_big_width, $image_big_height, $images_big_path . '/' . $datei, $quality_image_big);
			echo preg_replace('#\.gif$#i', '.jpg', $datei) . "<br />";
		}
	}
	closedir($dh);

	if ($pics_text) {
		if (count($existing_pics_list) == 0)
			$pics_text = "IMAGE\r\n" . $pics_text;
		$fh = fopen($images_big_path . '/_pics.txt', 'a');
		fwrite($fh, $pics_text);
		fclose($fh);
		@ chmod($images_big_path . '/_pics.txt', 0777);
	}

	echo "</div>\n";
}

function scale_image($img_source, $max_width, $max_height, $img_target = '', $image_quality = 85) {
	if (empty ($img_target)) {
		$img_target = $img_source;
	}

	if (preg_match('#\.jpg$|\.png$|\.gif$#i', $img_source) and ($max_width or $max_height)) {
		list ($orig_width, $orig_height) = getimagesize($img_source);
		if ($max_width and !$max_height and $max_width < $orig_width) {
			$new_width = $max_width;
			$new_height = round($orig_height / $orig_width * $max_width);
			$do_scale = TRUE;
		} else
			if ($max_height and !$max_width and $max_height < $orig_height) {
				$new_width = round($orig_width / $orig_height * $max_height);
				$new_height = $max_height;
				$do_scale = TRUE;
			} else
				if ($max_width and $max_height and ($max_width < $orig_width or $max_height < $orig_height)) {
					if ($orig_width / $max_width >= $orig_height / $max_height) {
						$new_width = $max_width;
						$new_height = round($orig_height / $orig_width * $max_width);
						$do_scale = TRUE;
					} else {
						$new_width = round($orig_width / $orig_height * $max_height);
						$new_height = $max_height;
						$do_scale = TRUE;
					}
				}

		if ($do_scale == TRUE) {
			if (preg_match('#\.jpg$#i', $img_source)) {
				$img_orig = imagecreatefromjpeg($img_source);
			} else
				if (preg_match('#\.png#i', $img_source)) {
					$img_orig = imagecreatefrompng($img_source);
				} else
					if (preg_match('#\.gif$#i', $img_source)) {
						$img_orig = imagecreatefromgif($img_source);
						$img_target = preg_replace('#\.gif$#i', '.jpg', $img_target);
					}
			if (!($img_new = @ imagecreatetruecolor($new_width, $new_height))) {
				$img_new = imagecreate($new_width, $new_height);
			}
			$bgColor = imagecolorallocate($img_new, 255, 255, 255);
			imagefill($img_new, 0, 0, $bgColor);
			if ($img_orig and $img_new) {
				if (!(@ imagecopyresampled($img_new, $img_orig, 0, 0, 0, 0, $new_width, $new_height, $orig_width, $orig_height))) {
					imagecopyresized($img_new, $img_orig, 0, 0, 0, 0, $new_width, $new_height, $orig_width, $orig_height);
				}
				if (preg_match('#\.png#i', $img_source)) {
					imagepng($img_new, $img_target);
				} else {
					imagejpeg($img_new, $img_target, $image_quality);
				}
				imagedestroy($img_orig);
				imagedestroy($img_new);
				@ chmod($img_target, 0777);
			}
		} else {
			if (preg_match('#\.gif$#i', $img_source)) {
				$img_orig = imagecreatefromgif($img_source);
				$img_target = preg_replace('#\.gif$#i', '.jpg', $img_target);
				if (!($img_new = @ imagecreatetruecolor($orig_width, $orig_height))) {
					$img_new = imagecreate($orig_width, $orig_height);
				}
				imagecopyresampled($img_new, $img_orig, 0, 0, 0, 0, $orig_width, $orig_height, $orig_width, $orig_height);
				imagejpeg($img_new, $img_target, $image_quality);
				imagedestroy($img_orig);
				imagedestroy($img_new);
			} else {
				copy($img_source, $img_target);
			}
			@ chmod($img_target, 0777);
		}
	}
	$match = '';
	;
	$datei_name = preg_match('#([^/]+$)#', $img_target, $match);
	return $match[0];
}
?>

<p id="copy">Image Resizer - &copy; 2008 by Peter Garstenauer &amp; Reynhard Boegl for <a href="http://www.kick-image.at">www.kick-image.at</a></p>

</body>
</html>
